"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getContentType = void 0;
function getContentType(reqProps, isV3) {
    var _a, _b;
    if (isV3) {
        if ((_a = reqProps === null || reqProps === void 0 ? void 0 : reqProps.requestBody) === null || _a === void 0 ? void 0 : _a.content) {
            const ct_keys = Object.keys((_b = reqProps === null || reqProps === void 0 ? void 0 : reqProps.requestBody) === null || _b === void 0 ? void 0 : _b.content);
            if (ct_keys.length > 0) {
                return ct_keys.includes('multipart/form-data') ? 'multipart/form-data' : ct_keys[0];
            }
        }
        return 'application/json';
    }
    else {
        if ((reqProps === null || reqProps === void 0 ? void 0 : reqProps.consumes) && (reqProps === null || reqProps === void 0 ? void 0 : reqProps.consumes.length) > 0) {
            return reqProps.consumes.includes('multipart/form-data') ? 'multipart/form-data' : reqProps.consumes[0];
        }
        return 'application/json';
    }
}
exports.getContentType = getContentType;
//# sourceMappingURL=getContentType.js.map